/* desktop_item.c generated by valac 0.56.3, the Vala compiler
 * generated from desktop_item.vala, do not modify */

/*
Copyright 2022 Buddies of Budgie
Copyright 2021 Solus Project

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

#include <gtk/gtk.h>
#include <glib-object.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <gio/gio.h>
#include <pango/pango.h>
#include <gdk/gdk.h>
#include <float.h>
#include <math.h>
#include <glib/gi18n-lib.h>

#define ITEM_MARGIN 10
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_DESKTOP_ITEM (desktop_item_get_type ())
#define DESKTOP_ITEM(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DESKTOP_ITEM, DesktopItem))
#define DESKTOP_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DESKTOP_ITEM, DesktopItemClass))
#define IS_DESKTOP_ITEM(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DESKTOP_ITEM))
#define IS_DESKTOP_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DESKTOP_ITEM))
#define DESKTOP_ITEM_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DESKTOP_ITEM, DesktopItemClass))

typedef struct _DesktopItem DesktopItem;
typedef struct _DesktopItemClass DesktopItemClass;
typedef struct _DesktopItemPrivate DesktopItemPrivate;

#define TYPE_UNIFIED_PROPS (unified_props_get_type ())
#define UNIFIED_PROPS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_UNIFIED_PROPS, UnifiedProps))
#define UNIFIED_PROPS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_UNIFIED_PROPS, UnifiedPropsClass))
#define IS_UNIFIED_PROPS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_UNIFIED_PROPS))
#define IS_UNIFIED_PROPS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_UNIFIED_PROPS))
#define UNIFIED_PROPS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_UNIFIED_PROPS, UnifiedPropsClass))

typedef struct _UnifiedProps UnifiedProps;
typedef struct _UnifiedPropsClass UnifiedPropsClass;
enum  {
	DESKTOP_ITEM_0_PROPERTY,
	DESKTOP_ITEM_IS_COPYING_PROPERTY,
	DESKTOP_ITEM_IS_MOUNT_PROPERTY,
	DESKTOP_ITEM_IS_SPECIAL_PROPERTY,
	DESKTOP_ITEM_ITEM_TYPE_PROPERTY,
	DESKTOP_ITEM_LABEL_NAME_PROPERTY,
	DESKTOP_ITEM_NUM_PROPERTIES
};
static GParamSpec* desktop_item_properties[DESKTOP_ITEM_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _UnifiedPropsPrivate UnifiedPropsPrivate;

#define TYPE_FILE_MENU (file_menu_get_type ())
#define FILE_MENU(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_FILE_MENU, FileMenu))
#define FILE_MENU_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_FILE_MENU, FileMenuClass))
#define IS_FILE_MENU(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_FILE_MENU))
#define IS_FILE_MENU_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_FILE_MENU))
#define FILE_MENU_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_FILE_MENU, FileMenuClass))

typedef struct _FileMenu FileMenu;
typedef struct _FileMenuClass FileMenuClass;
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

struct _DesktopItem {
	GtkFlowBoxChild parent_instance;
	DesktopItemPrivate * priv;
	UnifiedProps* props;
	gint _label_width;
	gboolean _copying;
	gboolean _mount;
	gchar* _name;
	gchar* _type;
	gboolean _special_dir;
	GtkImage* image;
	GtkLabel* label;
	GtkEventBox* event_box;
	GtkBox* main_layout;
	GdkPixbuf* original_image_pixbuf;
	GIcon* icon;
};

struct _DesktopItemClass {
	GtkFlowBoxChildClass parent_class;
};

struct _UnifiedProps {
	GObject parent_instance;
	UnifiedPropsPrivate * priv;
	GHashTable* files_currently_copying;
	FileMenu* file_menu;
	GdkCursor* blocked_cursor;
	GdkCursor* hand_cursor;
	GtkIconTheme* icon_theme;
	gint* icon_size;
	gint* s_factor;
};

struct _UnifiedPropsClass {
	GObjectClass parent_class;
};

static gpointer desktop_item_parent_class = NULL;

VALA_EXTERN GType desktop_item_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DesktopItem, g_object_unref)
VALA_EXTERN GType unified_props_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (UnifiedProps, g_object_unref)
VALA_EXTERN DesktopItem* desktop_item_new (void);
VALA_EXTERN DesktopItem* desktop_item_construct (GType object_type);
static gboolean desktop_item_on_enter (DesktopItem* self,
                                GdkEventCrossing* event);
static gboolean _desktop_item_on_enter_gtk_widget_enter_notify_event (GtkWidget* _sender,
                                                               GdkEventCrossing* event,
                                                               gpointer self);
static gboolean desktop_item_on_leave (DesktopItem* self,
                                GdkEventCrossing* event);
static gboolean _desktop_item_on_leave_gtk_widget_leave_notify_event (GtkWidget* _sender,
                                                               GdkEventCrossing* event,
                                                               gpointer self);
VALA_EXTERN GType file_menu_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (FileMenu, g_object_unref)
VALA_EXTERN void desktop_item_request_show (DesktopItem* self);
VALA_EXTERN void desktop_item_saturate_image (DesktopItem* self,
                                  gfloat val);
VALA_EXTERN void desktop_item_set_icon (DesktopItem* self,
                            GIcon* ico,
                            GError** error);
VALA_EXTERN void desktop_item_set_icon_from_iconinfo (DesktopItem* self,
                                          GtkIconInfo* icon_info,
                                          GError** error);
VALA_EXTERN void desktop_item_set_icon_from_name (DesktopItem* self,
                                      const gchar* icon_name,
                                      GError** error);
VALA_EXTERN void desktop_item_set_image_pixbuf (DesktopItem* self,
                                    GdkPixbuf* pix);
VALA_EXTERN void desktop_item_set_icon_factors (DesktopItem* self,
                                    GError** error);
static gboolean _int_equal (const gint * s1,
                     const gint * s2);
VALA_EXTERN gboolean desktop_item_get_is_copying (DesktopItem* self);
VALA_EXTERN void desktop_item_set_is_copying (DesktopItem* self,
                                  gboolean value);
VALA_EXTERN gboolean desktop_item_get_is_mount (DesktopItem* self);
VALA_EXTERN void desktop_item_set_is_mount (DesktopItem* self,
                                gboolean value);
VALA_EXTERN gboolean desktop_item_get_is_special (DesktopItem* self);
VALA_EXTERN void desktop_item_set_is_special (DesktopItem* self,
                                  gboolean value);
VALA_EXTERN const gchar* desktop_item_get_item_type (DesktopItem* self);
VALA_EXTERN const gchar* desktop_item_get_label_name (DesktopItem* self);
VALA_EXTERN void desktop_item_set_label_name (DesktopItem* self,
                                  const gchar* value);
static void desktop_item_finalize (GObject * obj);
static GType desktop_item_get_type_once (void);
static void _vala_desktop_item_get_property (GObject * object,
                                      guint property_id,
                                      GValue * value,
                                      GParamSpec * pspec);
static void _vala_desktop_item_set_property (GObject * object,
                                      guint property_id,
                                      const GValue * value,
                                      GParamSpec * pspec);

static gboolean
_desktop_item_on_enter_gtk_widget_enter_notify_event (GtkWidget* _sender,
                                                      GdkEventCrossing* event,
                                                      gpointer self)
{
	gboolean result;
	result = desktop_item_on_enter ((DesktopItem*) self, event);
#line 67 "../src/desktop_item.vala"
	return result;
#line 200 "desktop_item.c"
}

static gboolean
_desktop_item_on_leave_gtk_widget_leave_notify_event (GtkWidget* _sender,
                                                      GdkEventCrossing* event,
                                                      gpointer self)
{
	gboolean result;
	result = desktop_item_on_leave ((DesktopItem*) self, event);
#line 68 "../src/desktop_item.vala"
	return result;
#line 212 "desktop_item.c"
}

DesktopItem*
desktop_item_construct (GType object_type)
{
	DesktopItem * self = NULL;
	GtkEventBox* _tmp0_;
	GtkBox* _tmp1_;
	GtkBox* _tmp2_;
	GtkLabel* _tmp3_;
	GtkLabel* _tmp4_;
	GtkStyleContext* _tmp5_;
	GtkLabel* _tmp6_;
	GtkLabel* _tmp7_;
	GtkLabel* _tmp8_;
	GtkLabel* _tmp9_;
	GtkLabel* _tmp10_;
	GtkBox* _tmp11_;
	GtkLabel* _tmp12_;
	GtkEventBox* _tmp13_;
	GtkBox* _tmp14_;
	GtkEventBox* _tmp15_;
	GtkEventBox* _tmp16_;
	GtkEventBox* _tmp17_;
	GtkEventBox* _tmp18_;
#line 40 "../src/desktop_item.vala"
	self = (DesktopItem*) g_object_new (object_type, NULL);
#line 41 "../src/desktop_item.vala"
	g_object_set ((GtkWidget*) self, "expand", TRUE, NULL);
#line 42 "../src/desktop_item.vala"
	g_object_set ((GtkWidget*) self, "margin", ITEM_MARGIN, NULL);
#line 43 "../src/desktop_item.vala"
	gtk_widget_set_no_show_all ((GtkWidget*) self, TRUE);
#line 44 "../src/desktop_item.vala"
	gtk_widget_set_valign ((GtkWidget*) self, GTK_ALIGN_CENTER);
#line 46 "../src/desktop_item.vala"
	self->_copying = FALSE;
#line 47 "../src/desktop_item.vala"
	self->_special_dir = FALSE;
#line 49 "../src/desktop_item.vala"
	_tmp0_ = (GtkEventBox*) gtk_event_box_new ();
#line 49 "../src/desktop_item.vala"
	g_object_ref_sink (_tmp0_);
#line 49 "../src/desktop_item.vala"
	_g_object_unref0 (self->event_box);
#line 49 "../src/desktop_item.vala"
	self->event_box = _tmp0_;
#line 51 "../src/desktop_item.vala"
	_tmp1_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_VERTICAL, 0);
#line 51 "../src/desktop_item.vala"
	g_object_ref_sink (_tmp1_);
#line 51 "../src/desktop_item.vala"
	_g_object_unref0 (self->main_layout);
#line 51 "../src/desktop_item.vala"
	self->main_layout = _tmp1_;
#line 52 "../src/desktop_item.vala"
	_tmp2_ = self->main_layout;
#line 52 "../src/desktop_item.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp2_, TRUE);
#line 54 "../src/desktop_item.vala"
	_tmp3_ = (GtkLabel*) gtk_label_new (NULL);
#line 54 "../src/desktop_item.vala"
	g_object_ref_sink (_tmp3_);
#line 54 "../src/desktop_item.vala"
	_g_object_unref0 (self->label);
#line 54 "../src/desktop_item.vala"
	self->label = _tmp3_;
#line 55 "../src/desktop_item.vala"
	_tmp4_ = self->label;
#line 55 "../src/desktop_item.vala"
	_tmp5_ = gtk_widget_get_style_context ((GtkWidget*) _tmp4_);
#line 55 "../src/desktop_item.vala"
	gtk_style_context_add_class (_tmp5_, "desktop-item-label");
#line 56 "../src/desktop_item.vala"
	_tmp6_ = self->label;
#line 56 "../src/desktop_item.vala"
	gtk_label_set_ellipsize (_tmp6_, PANGO_ELLIPSIZE_END);
#line 57 "../src/desktop_item.vala"
	_tmp7_ = self->label;
#line 57 "../src/desktop_item.vala"
	gtk_label_set_justify (_tmp7_, GTK_JUSTIFY_CENTER);
#line 58 "../src/desktop_item.vala"
	_tmp8_ = self->label;
#line 58 "../src/desktop_item.vala"
	gtk_label_set_lines (_tmp8_, 2);
#line 59 "../src/desktop_item.vala"
	_tmp9_ = self->label;
#line 59 "../src/desktop_item.vala"
	g_object_set (_tmp9_, "wrap-mode", PANGO_WRAP_WORD_CHAR, NULL);
#line 60 "../src/desktop_item.vala"
	_tmp10_ = self->label;
#line 60 "../src/desktop_item.vala"
	g_object_set (_tmp10_, "wrap", TRUE, NULL);
#line 62 "../src/desktop_item.vala"
	_tmp11_ = self->main_layout;
#line 62 "../src/desktop_item.vala"
	_tmp12_ = self->label;
#line 62 "../src/desktop_item.vala"
	gtk_box_pack_end (_tmp11_, (GtkWidget*) _tmp12_, TRUE, TRUE, (guint) 0);
#line 63 "../src/desktop_item.vala"
	_tmp13_ = self->event_box;
#line 63 "../src/desktop_item.vala"
	_tmp14_ = self->main_layout;
#line 63 "../src/desktop_item.vala"
	gtk_container_add ((GtkContainer*) _tmp13_, (GtkWidget*) _tmp14_);
#line 65 "../src/desktop_item.vala"
	_tmp15_ = self->event_box;
#line 65 "../src/desktop_item.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp15_);
#line 66 "../src/desktop_item.vala"
	_tmp16_ = self->event_box;
#line 66 "../src/desktop_item.vala"
	gtk_widget_set_events ((GtkWidget*) _tmp16_, (gint) ((GDK_BUTTON_PRESS_MASK & GDK_ENTER_NOTIFY_MASK) & GDK_LEAVE_NOTIFY_MASK));
#line 67 "../src/desktop_item.vala"
	_tmp17_ = self->event_box;
#line 67 "../src/desktop_item.vala"
	g_signal_connect_object ((GtkWidget*) _tmp17_, "enter-notify-event", (GCallback) _desktop_item_on_enter_gtk_widget_enter_notify_event, self, 0);
#line 68 "../src/desktop_item.vala"
	_tmp18_ = self->event_box;
#line 68 "../src/desktop_item.vala"
	g_signal_connect_object ((GtkWidget*) _tmp18_, "leave-notify-event", (GCallback) _desktop_item_on_leave_gtk_widget_leave_notify_event, self, 0);
#line 39 "../src/desktop_item.vala"
	return self;
#line 336 "desktop_item.c"
}

DesktopItem*
desktop_item_new (void)
{
#line 39 "../src/desktop_item.vala"
	return desktop_item_construct (TYPE_DESKTOP_ITEM);
#line 344 "desktop_item.c"
}

static gboolean
desktop_item_on_enter (DesktopItem* self,
                       GdkEventCrossing* event)
{
	GtkLabel* _tmp0_;
	GtkStyleContext* _tmp1_;
	gboolean result;
#line 131 "../src/desktop_item.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 131 "../src/desktop_item.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 132 "../src/desktop_item.vala"
	if (event->mode != GDK_CROSSING_NORMAL) {
#line 133 "../src/desktop_item.vala"
		result = GDK_EVENT_STOP;
#line 133 "../src/desktop_item.vala"
		return result;
#line 364 "desktop_item.c"
	}
#line 136 "../src/desktop_item.vala"
	_tmp0_ = self->label;
#line 136 "../src/desktop_item.vala"
	_tmp1_ = gtk_widget_get_style_context ((GtkWidget*) _tmp0_);
#line 136 "../src/desktop_item.vala"
	gtk_style_context_add_class (_tmp1_, "selected");
#line 138 "../src/desktop_item.vala"
	if (self->_copying) {
#line 374 "desktop_item.c"
		GdkWindow* _tmp2_;
		UnifiedProps* _tmp3_;
		GdkCursor* _tmp4_;
#line 139 "../src/desktop_item.vala"
		_tmp2_ = gtk_widget_get_window ((GtkWidget*) self);
#line 139 "../src/desktop_item.vala"
		_tmp3_ = self->props;
#line 139 "../src/desktop_item.vala"
		_tmp4_ = _tmp3_->blocked_cursor;
#line 139 "../src/desktop_item.vala"
		gdk_window_set_cursor (_tmp2_, _tmp4_);
#line 386 "desktop_item.c"
	} else {
		GdkWindow* _tmp5_;
		UnifiedProps* _tmp6_;
		GdkCursor* _tmp7_;
#line 141 "../src/desktop_item.vala"
		_tmp5_ = gtk_widget_get_window ((GtkWidget*) self);
#line 141 "../src/desktop_item.vala"
		_tmp6_ = self->props;
#line 141 "../src/desktop_item.vala"
		_tmp7_ = _tmp6_->hand_cursor;
#line 141 "../src/desktop_item.vala"
		gdk_window_set_cursor (_tmp5_, _tmp7_);
#line 399 "desktop_item.c"
	}
#line 143 "../src/desktop_item.vala"
	result = GDK_EVENT_STOP;
#line 143 "../src/desktop_item.vala"
	return result;
#line 405 "desktop_item.c"
}

static gboolean
desktop_item_on_leave (DesktopItem* self,
                       GdkEventCrossing* event)
{
	GtkLabel* _tmp1_;
	GtkStyleContext* _tmp2_;
	GdkWindow* _tmp3_;
	gboolean result;
#line 147 "../src/desktop_item.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 147 "../src/desktop_item.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 148 "../src/desktop_item.vala"
	if (event->mode != GDK_CROSSING_NORMAL) {
#line 422 "desktop_item.c"
		GdkWindow* _tmp0_;
#line 149 "../src/desktop_item.vala"
		_tmp0_ = gtk_widget_get_window ((GtkWidget*) self);
#line 149 "../src/desktop_item.vala"
		gdk_window_set_cursor (_tmp0_, NULL);
#line 150 "../src/desktop_item.vala"
		result = GDK_EVENT_STOP;
#line 150 "../src/desktop_item.vala"
		return result;
#line 432 "desktop_item.c"
	}
#line 153 "../src/desktop_item.vala"
	_tmp1_ = self->label;
#line 153 "../src/desktop_item.vala"
	_tmp2_ = gtk_widget_get_style_context ((GtkWidget*) _tmp1_);
#line 153 "../src/desktop_item.vala"
	gtk_style_context_remove_class (_tmp2_, "selected");
#line 154 "../src/desktop_item.vala"
	_tmp3_ = gtk_widget_get_window ((GtkWidget*) self);
#line 154 "../src/desktop_item.vala"
	gdk_window_set_cursor (_tmp3_, NULL);
#line 155 "../src/desktop_item.vala"
	result = GDK_EVENT_STOP;
#line 155 "../src/desktop_item.vala"
	return result;
#line 448 "desktop_item.c"
}

void
desktop_item_request_show (DesktopItem* self)
{
	GtkBox* _tmp0_;
	GtkEventBox* _tmp1_;
	GtkImage* _tmp2_;
	GtkLabel* _tmp4_;
#line 159 "../src/desktop_item.vala"
	g_return_if_fail (self != NULL);
#line 160 "../src/desktop_item.vala"
	gtk_widget_show ((GtkWidget*) self);
#line 161 "../src/desktop_item.vala"
	_tmp0_ = self->main_layout;
#line 161 "../src/desktop_item.vala"
	gtk_widget_show ((GtkWidget*) _tmp0_);
#line 162 "../src/desktop_item.vala"
	_tmp1_ = self->event_box;
#line 162 "../src/desktop_item.vala"
	gtk_widget_show ((GtkWidget*) _tmp1_);
#line 164 "../src/desktop_item.vala"
	_tmp2_ = self->image;
#line 164 "../src/desktop_item.vala"
	if (_tmp2_ != NULL) {
#line 474 "desktop_item.c"
		GtkImage* _tmp3_;
#line 165 "../src/desktop_item.vala"
		_tmp3_ = self->image;
#line 165 "../src/desktop_item.vala"
		gtk_widget_show ((GtkWidget*) _tmp3_);
#line 480 "desktop_item.c"
	}
#line 168 "../src/desktop_item.vala"
	_tmp4_ = self->label;
#line 168 "../src/desktop_item.vala"
	if (_tmp4_ != NULL) {
#line 486 "desktop_item.c"
		GtkLabel* _tmp5_;
#line 169 "../src/desktop_item.vala"
		_tmp5_ = self->label;
#line 169 "../src/desktop_item.vala"
		gtk_widget_show ((GtkWidget*) _tmp5_);
#line 492 "desktop_item.c"
	}
}

void
desktop_item_saturate_image (DesktopItem* self,
                             gfloat val)
{
	GtkImage* _tmp0_;
	GdkPixbuf* saturated_pixbuf = NULL;
	GdkPixbuf* _tmp1_;
	GdkPixbuf* _tmp2_;
	GdkPixbuf* _tmp3_;
	GdkPixbuf* _tmp4_;
	GtkImage* _tmp5_;
	GdkPixbuf* _tmp6_;
#line 175 "../src/desktop_item.vala"
	g_return_if_fail (self != NULL);
#line 176 "../src/desktop_item.vala"
	_tmp0_ = self->image;
#line 176 "../src/desktop_item.vala"
	if (_tmp0_ == NULL) {
#line 177 "../src/desktop_item.vala"
		return;
#line 516 "desktop_item.c"
	}
#line 180 "../src/desktop_item.vala"
	_tmp1_ = self->original_image_pixbuf;
#line 180 "../src/desktop_item.vala"
	_tmp2_ = gdk_pixbuf_copy (_tmp1_);
#line 180 "../src/desktop_item.vala"
	saturated_pixbuf = _tmp2_;
#line 181 "../src/desktop_item.vala"
	_tmp3_ = self->original_image_pixbuf;
#line 181 "../src/desktop_item.vala"
	_tmp4_ = saturated_pixbuf;
#line 181 "../src/desktop_item.vala"
	gdk_pixbuf_saturate_and_pixelate (_tmp3_, _tmp4_, val, FALSE);
#line 183 "../src/desktop_item.vala"
	_tmp5_ = self->image;
#line 183 "../src/desktop_item.vala"
	_tmp6_ = saturated_pixbuf;
#line 183 "../src/desktop_item.vala"
	gtk_image_set_from_pixbuf (_tmp5_, _tmp6_);
#line 175 "../src/desktop_item.vala"
	_g_object_unref0 (saturated_pixbuf);
#line 538 "desktop_item.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 192 "../src/desktop_item.vala"
	return self ? g_object_ref (self) : NULL;
#line 546 "desktop_item.c"
}

void
desktop_item_set_icon (DesktopItem* self,
                       GIcon* ico,
                       GError** error)
{
	GIcon* _tmp0_;
	GtkIconInfo* icon_info = NULL;
	UnifiedProps* _tmp1_;
	GtkIconTheme* _tmp2_;
	GIcon* _tmp3_;
	UnifiedProps* _tmp4_;
	gint* _tmp5_;
	UnifiedProps* _tmp6_;
	gint* _tmp7_;
	GtkIconInfo* _tmp8_;
	GtkIconInfo* _tmp9_;
	GError* _inner_error0_ = NULL;
#line 187 "../src/desktop_item.vala"
	g_return_if_fail (self != NULL);
#line 187 "../src/desktop_item.vala"
	g_return_if_fail (ico != NULL);
#line 188 "../src/desktop_item.vala"
	if (ico == NULL) {
#line 189 "../src/desktop_item.vala"
		return;
#line 574 "desktop_item.c"
	}
#line 192 "../src/desktop_item.vala"
	_tmp0_ = _g_object_ref0 (ico);
#line 192 "../src/desktop_item.vala"
	_g_object_unref0 (self->icon);
#line 192 "../src/desktop_item.vala"
	self->icon = _tmp0_;
#line 194 "../src/desktop_item.vala"
	_tmp1_ = self->props;
#line 194 "../src/desktop_item.vala"
	_tmp2_ = _tmp1_->icon_theme;
#line 194 "../src/desktop_item.vala"
	_tmp3_ = self->icon;
#line 194 "../src/desktop_item.vala"
	_tmp4_ = self->props;
#line 194 "../src/desktop_item.vala"
	_tmp5_ = _tmp4_->icon_size;
#line 194 "../src/desktop_item.vala"
	_tmp6_ = self->props;
#line 194 "../src/desktop_item.vala"
	_tmp7_ = _tmp6_->s_factor;
#line 194 "../src/desktop_item.vala"
	_tmp8_ = gtk_icon_theme_lookup_by_gicon_for_scale (_tmp2_, _tmp3_, *_tmp5_, *_tmp7_, GTK_ICON_LOOKUP_USE_BUILTIN & GTK_ICON_LOOKUP_GENERIC_FALLBACK);
#line 194 "../src/desktop_item.vala"
	icon_info = _tmp8_;
#line 195 "../src/desktop_item.vala"
	_tmp9_ = icon_info;
#line 195 "../src/desktop_item.vala"
	desktop_item_set_icon_from_iconinfo (self, _tmp9_, &_inner_error0_);
#line 195 "../src/desktop_item.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 195 "../src/desktop_item.vala"
		g_propagate_error (error, _inner_error0_);
#line 195 "../src/desktop_item.vala"
		_g_object_unref0 (icon_info);
#line 195 "../src/desktop_item.vala"
		return;
#line 612 "desktop_item.c"
	}
#line 187 "../src/desktop_item.vala"
	_g_object_unref0 (icon_info);
#line 616 "desktop_item.c"
}

static gpointer
_g_error_copy0 (gpointer self)
{
#line 204 "../src/desktop_item.vala"
	return self ? g_error_copy (self) : NULL;
#line 624 "desktop_item.c"
}

void
desktop_item_set_icon_from_name (DesktopItem* self,
                                 const gchar* icon_name,
                                 GError** error)
{
	GError* _inner_error0_ = NULL;
#line 199 "../src/desktop_item.vala"
	g_return_if_fail (self != NULL);
#line 199 "../src/desktop_item.vala"
	g_return_if_fail (icon_name != NULL);
#line 637 "desktop_item.c"
	{
		GdkPixbuf* pix = NULL;
		UnifiedProps* _tmp0_;
		GtkIconTheme* _tmp1_;
		UnifiedProps* _tmp2_;
		gint* _tmp3_;
		UnifiedProps* _tmp4_;
		gint* _tmp5_;
		GdkPixbuf* _tmp6_;
		GdkPixbuf* _tmp7_;
#line 201 "../src/desktop_item.vala"
		_tmp0_ = self->props;
#line 201 "../src/desktop_item.vala"
		_tmp1_ = _tmp0_->icon_theme;
#line 201 "../src/desktop_item.vala"
		_tmp2_ = self->props;
#line 201 "../src/desktop_item.vala"
		_tmp3_ = _tmp2_->icon_size;
#line 201 "../src/desktop_item.vala"
		_tmp4_ = self->props;
#line 201 "../src/desktop_item.vala"
		_tmp5_ = _tmp4_->s_factor;
#line 201 "../src/desktop_item.vala"
		_tmp6_ = gtk_icon_theme_load_icon_for_scale (_tmp1_, icon_name, *_tmp3_, *_tmp5_, GTK_ICON_LOOKUP_GENERIC_FALLBACK, &_inner_error0_);
#line 201 "../src/desktop_item.vala"
		pix = _tmp6_;
#line 201 "../src/desktop_item.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 666 "desktop_item.c"
			goto __catch0_g_error;
		}
#line 202 "../src/desktop_item.vala"
		_tmp7_ = pix;
#line 202 "../src/desktop_item.vala"
		desktop_item_set_image_pixbuf (self, _tmp7_);
#line 200 "../src/desktop_item.vala"
		_g_object_unref0 (pix);
#line 675 "desktop_item.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp8_;
		GError* _tmp9_;
#line 200 "../src/desktop_item.vala"
		e = _inner_error0_;
#line 200 "../src/desktop_item.vala"
		_inner_error0_ = NULL;
#line 204 "../src/desktop_item.vala"
		_tmp8_ = e;
#line 204 "../src/desktop_item.vala"
		_tmp9_ = _g_error_copy0 (_tmp8_);
#line 204 "../src/desktop_item.vala"
		_inner_error0_ = _tmp9_;
#line 204 "../src/desktop_item.vala"
		_g_error_free0 (e);
#line 695 "desktop_item.c"
		goto __finally0;
	}
	__finally0:
#line 200 "../src/desktop_item.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 200 "../src/desktop_item.vala"
		g_propagate_error (error, _inner_error0_);
#line 200 "../src/desktop_item.vala"
		return;
#line 705 "desktop_item.c"
	}
}

void
desktop_item_set_icon_from_iconinfo (DesktopItem* self,
                                     GtkIconInfo* icon_info,
                                     GError** error)
{
	GdkPixbuf* pix = NULL;
	GdkPixbuf* _tmp8_;
	UnifiedProps* _tmp9_;
	gint* _tmp10_;
	GdkPixbuf* _tmp17_;
	GError* _inner_error0_ = NULL;
#line 209 "../src/desktop_item.vala"
	g_return_if_fail (self != NULL);
#line 210 "../src/desktop_item.vala"
	if (icon_info == NULL) {
#line 724 "desktop_item.c"
		const gchar* _tmp0_;
		const gchar* _tmp1_;
		GError* _tmp2_;
#line 211 "../src/desktop_item.vala"
		_tmp0_ = gtk_widget_get_name ((GtkWidget*) self);
#line 211 "../src/desktop_item.vala"
		_tmp1_ = _tmp0_;
#line 211 "../src/desktop_item.vala"
		_tmp2_ = g_error_new (GTK_ICON_THEME_ERROR, GTK_ICON_THEME_FAILED, "Failed to load icon for: %s\n", _tmp1_);
#line 211 "../src/desktop_item.vala"
		_inner_error0_ = _tmp2_;
#line 211 "../src/desktop_item.vala"
		g_propagate_error (error, _inner_error0_);
#line 211 "../src/desktop_item.vala"
		return;
#line 740 "desktop_item.c"
	}
#line 214 "../src/desktop_item.vala"
	pix = NULL;
#line 744 "desktop_item.c"
	{
		GdkPixbuf* _tmp3_ = NULL;
		GdkPixbuf* _tmp4_;
		GdkPixbuf* _tmp5_;
#line 217 "../src/desktop_item.vala"
		_tmp4_ = gtk_icon_info_load_icon (icon_info, &_inner_error0_);
#line 217 "../src/desktop_item.vala"
		_tmp3_ = _tmp4_;
#line 217 "../src/desktop_item.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 755 "desktop_item.c"
			goto __catch0_g_error;
		}
#line 217 "../src/desktop_item.vala"
		_tmp5_ = _tmp3_;
#line 217 "../src/desktop_item.vala"
		_tmp3_ = NULL;
#line 217 "../src/desktop_item.vala"
		_g_object_unref0 (pix);
#line 217 "../src/desktop_item.vala"
		pix = _tmp5_;
#line 216 "../src/desktop_item.vala"
		_g_object_unref0 (_tmp3_);
#line 768 "desktop_item.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp6_;
		GError* _tmp7_;
#line 216 "../src/desktop_item.vala"
		e = _inner_error0_;
#line 216 "../src/desktop_item.vala"
		_inner_error0_ = NULL;
#line 219 "../src/desktop_item.vala"
		_tmp6_ = e;
#line 219 "../src/desktop_item.vala"
		_tmp7_ = _g_error_copy0 (_tmp6_);
#line 219 "../src/desktop_item.vala"
		_inner_error0_ = _tmp7_;
#line 219 "../src/desktop_item.vala"
		_g_error_free0 (e);
#line 788 "desktop_item.c"
		goto __finally0;
	}
	__finally0:
#line 216 "../src/desktop_item.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 216 "../src/desktop_item.vala"
		g_propagate_error (error, _inner_error0_);
#line 216 "../src/desktop_item.vala"
		_g_object_unref0 (pix);
#line 216 "../src/desktop_item.vala"
		return;
#line 800 "desktop_item.c"
	}
#line 222 "../src/desktop_item.vala"
	_tmp8_ = pix;
#line 222 "../src/desktop_item.vala"
	_tmp9_ = self->props;
#line 222 "../src/desktop_item.vala"
	_tmp10_ = _tmp9_->icon_size;
#line 222 "../src/desktop_item.vala"
	if (gdk_pixbuf_get_width (_tmp8_) > (*_tmp10_)) {
#line 810 "desktop_item.c"
		GdkPixbuf* _tmp11_;
		UnifiedProps* _tmp12_;
		gint* _tmp13_;
		UnifiedProps* _tmp14_;
		gint* _tmp15_;
		GdkPixbuf* _tmp16_;
#line 223 "../src/desktop_item.vala"
		_tmp11_ = pix;
#line 223 "../src/desktop_item.vala"
		_tmp12_ = self->props;
#line 223 "../src/desktop_item.vala"
		_tmp13_ = _tmp12_->icon_size;
#line 223 "../src/desktop_item.vala"
		_tmp14_ = self->props;
#line 223 "../src/desktop_item.vala"
		_tmp15_ = _tmp14_->icon_size;
#line 223 "../src/desktop_item.vala"
		_tmp16_ = gdk_pixbuf_scale_simple (_tmp11_, *_tmp13_, *_tmp15_, GDK_INTERP_BILINEAR);
#line 223 "../src/desktop_item.vala"
		_g_object_unref0 (pix);
#line 223 "../src/desktop_item.vala"
		pix = _tmp16_;
#line 833 "desktop_item.c"
	}
#line 226 "../src/desktop_item.vala"
	_tmp17_ = pix;
#line 226 "../src/desktop_item.vala"
	desktop_item_set_image_pixbuf (self, _tmp17_);
#line 209 "../src/desktop_item.vala"
	_g_object_unref0 (pix);
#line 841 "desktop_item.c"
}

static gboolean
_int_equal (const gint * s1,
            const gint * s2)
{
#line 235 "../src/desktop_item.vala"
	if (s1 == s2) {
#line 235 "../src/desktop_item.vala"
		return TRUE;
#line 852 "desktop_item.c"
	}
#line 235 "../src/desktop_item.vala"
	if (s1 == NULL) {
#line 235 "../src/desktop_item.vala"
		return FALSE;
#line 858 "desktop_item.c"
	}
#line 235 "../src/desktop_item.vala"
	if (s2 == NULL) {
#line 235 "../src/desktop_item.vala"
		return FALSE;
#line 864 "desktop_item.c"
	}
#line 235 "../src/desktop_item.vala"
	return (*s1) == (*s2);
#line 868 "desktop_item.c"
}

void
desktop_item_set_icon_factors (DesktopItem* self,
                               GError** error)
{
	UnifiedProps* _tmp0_;
	gint* _tmp1_;
	GIcon* _tmp18_;
	GError* _inner_error0_ = NULL;
#line 230 "../src/desktop_item.vala"
	g_return_if_fail (self != NULL);
#line 231 "../src/desktop_item.vala"
	_tmp0_ = self->props;
#line 231 "../src/desktop_item.vala"
	_tmp1_ = _tmp0_->icon_size;
#line 231 "../src/desktop_item.vala"
	if (_tmp1_ != NULL) {
#line 887 "desktop_item.c"
		UnifiedProps* _tmp2_;
		gint* _tmp3_;
		GtkLabel* _tmp16_;
		GtkLabel* _tmp17_;
#line 232 "../src/desktop_item.vala"
		_tmp2_ = self->props;
#line 232 "../src/desktop_item.vala"
		_tmp3_ = _tmp2_->icon_size;
#line 232 "../src/desktop_item.vala"
		if ((*_tmp3_) <= 48) {
#line 898 "desktop_item.c"
			GtkLabel* _tmp4_;
			GtkStyleContext* _tmp5_;
#line 233 "../src/desktop_item.vala"
			self->_label_width = 12;
#line 234 "../src/desktop_item.vala"
			_tmp4_ = self->label;
#line 234 "../src/desktop_item.vala"
			_tmp5_ = gtk_widget_get_style_context ((GtkWidget*) _tmp4_);
#line 234 "../src/desktop_item.vala"
			gtk_style_context_remove_class (_tmp5_, "larger-text");
#line 909 "desktop_item.c"
		} else {
			UnifiedProps* _tmp6_;
			gint* _tmp7_;
			gint _tmp8_;
#line 235 "../src/desktop_item.vala"
			_tmp6_ = self->props;
#line 235 "../src/desktop_item.vala"
			_tmp7_ = _tmp6_->icon_size;
#line 235 "../src/desktop_item.vala"
			_tmp8_ = 64;
#line 235 "../src/desktop_item.vala"
			if (_int_equal (_tmp7_, &_tmp8_) == TRUE) {
#line 922 "desktop_item.c"
				GtkLabel* _tmp9_;
				GtkStyleContext* _tmp10_;
#line 236 "../src/desktop_item.vala"
				self->_label_width = 18;
#line 237 "../src/desktop_item.vala"
				_tmp9_ = self->label;
#line 237 "../src/desktop_item.vala"
				_tmp10_ = gtk_widget_get_style_context ((GtkWidget*) _tmp9_);
#line 237 "../src/desktop_item.vala"
				gtk_style_context_add_class (_tmp10_, "larger-text");
#line 933 "desktop_item.c"
			} else {
				UnifiedProps* _tmp11_;
				gint* _tmp12_;
				gint _tmp13_;
#line 238 "../src/desktop_item.vala"
				_tmp11_ = self->props;
#line 238 "../src/desktop_item.vala"
				_tmp12_ = _tmp11_->icon_size;
#line 238 "../src/desktop_item.vala"
				_tmp13_ = 96;
#line 238 "../src/desktop_item.vala"
				if (_int_equal (_tmp12_, &_tmp13_) == TRUE) {
#line 946 "desktop_item.c"
					GtkLabel* _tmp14_;
					GtkStyleContext* _tmp15_;
#line 239 "../src/desktop_item.vala"
					self->_label_width = 20;
#line 240 "../src/desktop_item.vala"
					_tmp14_ = self->label;
#line 240 "../src/desktop_item.vala"
					_tmp15_ = gtk_widget_get_style_context ((GtkWidget*) _tmp14_);
#line 240 "../src/desktop_item.vala"
					gtk_style_context_add_class (_tmp15_, "larger-text");
#line 957 "desktop_item.c"
				}
			}
		}
#line 243 "../src/desktop_item.vala"
		_tmp16_ = self->label;
#line 243 "../src/desktop_item.vala"
		gtk_label_set_max_width_chars (_tmp16_, self->_label_width);
#line 244 "../src/desktop_item.vala"
		_tmp17_ = self->label;
#line 244 "../src/desktop_item.vala"
		gtk_label_set_width_chars (_tmp17_, self->_label_width);
#line 969 "desktop_item.c"
	}
#line 247 "../src/desktop_item.vala"
	_tmp18_ = self->icon;
#line 247 "../src/desktop_item.vala"
	if (_tmp18_ != NULL) {
#line 975 "desktop_item.c"
		{
			GIcon* _tmp19_;
#line 249 "../src/desktop_item.vala"
			_tmp19_ = self->icon;
#line 249 "../src/desktop_item.vala"
			desktop_item_set_icon (self, _tmp19_, &_inner_error0_);
#line 249 "../src/desktop_item.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 984 "desktop_item.c"
				goto __catch0_g_error;
			}
		}
		goto __finally0;
		__catch0_g_error:
		{
			GError* e = NULL;
			GError* _tmp20_;
			const gchar* _tmp21_;
#line 248 "../src/desktop_item.vala"
			e = _inner_error0_;
#line 248 "../src/desktop_item.vala"
			_inner_error0_ = NULL;
#line 251 "../src/desktop_item.vala"
			_tmp20_ = e;
#line 251 "../src/desktop_item.vala"
			_tmp21_ = _tmp20_->message;
#line 251 "../src/desktop_item.vala"
			g_warning ("desktop_item.vala:251: Failed to set icon: %s", _tmp21_);
#line 248 "../src/desktop_item.vala"
			_g_error_free0 (e);
#line 1006 "desktop_item.c"
		}
		__finally0:
#line 248 "../src/desktop_item.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 248 "../src/desktop_item.vala"
			g_propagate_error (error, _inner_error0_);
#line 248 "../src/desktop_item.vala"
			return;
#line 1015 "desktop_item.c"
		}
	}
}

void
desktop_item_set_image_pixbuf (DesktopItem* self,
                               GdkPixbuf* pix)
{
	GdkPixbuf* _tmp0_;
	GtkImage* _tmp1_;
#line 257 "../src/desktop_item.vala"
	g_return_if_fail (self != NULL);
#line 257 "../src/desktop_item.vala"
	g_return_if_fail (pix != NULL);
#line 258 "../src/desktop_item.vala"
	_tmp0_ = _g_object_ref0 (pix);
#line 258 "../src/desktop_item.vala"
	_g_object_unref0 (self->original_image_pixbuf);
#line 258 "../src/desktop_item.vala"
	self->original_image_pixbuf = _tmp0_;
#line 260 "../src/desktop_item.vala"
	_tmp1_ = self->image;
#line 260 "../src/desktop_item.vala"
	if (_tmp1_ == NULL) {
#line 1040 "desktop_item.c"
		GtkImage* _tmp2_;
		GtkImage* _tmp3_;
		GtkBox* _tmp4_;
		GtkImage* _tmp5_;
#line 261 "../src/desktop_item.vala"
		_tmp2_ = (GtkImage*) gtk_image_new_from_pixbuf (pix);
#line 261 "../src/desktop_item.vala"
		g_object_ref_sink (_tmp2_);
#line 261 "../src/desktop_item.vala"
		_g_object_unref0 (self->image);
#line 261 "../src/desktop_item.vala"
		self->image = _tmp2_;
#line 262 "../src/desktop_item.vala"
		_tmp3_ = self->image;
#line 262 "../src/desktop_item.vala"
		gtk_widget_set_margin_bottom ((GtkWidget*) _tmp3_, 10);
#line 263 "../src/desktop_item.vala"
		_tmp4_ = self->main_layout;
#line 263 "../src/desktop_item.vala"
		_tmp5_ = self->image;
#line 263 "../src/desktop_item.vala"
		gtk_box_pack_start (_tmp4_, (GtkWidget*) _tmp5_, TRUE, TRUE, (guint) 0);
#line 1063 "desktop_item.c"
	} else {
		GtkImage* _tmp6_;
#line 265 "../src/desktop_item.vala"
		_tmp6_ = self->image;
#line 265 "../src/desktop_item.vala"
		gtk_image_set_from_pixbuf (_tmp6_, pix);
#line 1070 "desktop_item.c"
	}
}

gboolean
desktop_item_get_is_copying (DesktopItem* self)
{
	gboolean result;
#line 72 "../src/desktop_item.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 73 "../src/desktop_item.vala"
	result = self->_copying;
#line 73 "../src/desktop_item.vala"
	return result;
#line 1084 "desktop_item.c"
}

void
desktop_item_set_is_copying (DesktopItem* self,
                             gboolean value)
{
	gfloat _tmp0_ = 0.0F;
#line 76 "../src/desktop_item.vala"
	g_return_if_fail (self != NULL);
#line 77 "../src/desktop_item.vala"
	self->_copying = value;
#line 78 "../src/desktop_item.vala"
	gtk_widget_set_has_tooltip ((GtkWidget*) self, value);
#line 79 "../src/desktop_item.vala"
	if (self->_copying) {
#line 79 "../src/desktop_item.vala"
		_tmp0_ = (gfloat) 0.5;
#line 1102 "desktop_item.c"
	} else {
#line 79 "../src/desktop_item.vala"
		_tmp0_ = (gfloat) 1.0;
#line 1106 "desktop_item.c"
	}
#line 79 "../src/desktop_item.vala"
	desktop_item_saturate_image (self, _tmp0_);
#line 81 "../src/desktop_item.vala"
	if (self->_copying) {
#line 1112 "desktop_item.c"
		GtkLabel* _tmp1_;
		GtkStyleContext* _tmp2_;
#line 82 "../src/desktop_item.vala"
		_tmp1_ = self->label;
#line 82 "../src/desktop_item.vala"
		_tmp2_ = gtk_widget_get_style_context ((GtkWidget*) _tmp1_);
#line 82 "../src/desktop_item.vala"
		gtk_style_context_add_class (_tmp2_, "is-disabled");
#line 83 "../src/desktop_item.vala"
		gtk_widget_set_tooltip_text ((GtkWidget*) self, _ ("File currently copying"));
#line 1123 "desktop_item.c"
	} else {
		GtkLabel* _tmp3_;
		GtkStyleContext* _tmp4_;
#line 85 "../src/desktop_item.vala"
		_tmp3_ = self->label;
#line 85 "../src/desktop_item.vala"
		_tmp4_ = gtk_widget_get_style_context ((GtkWidget*) _tmp3_);
#line 85 "../src/desktop_item.vala"
		gtk_style_context_remove_class (_tmp4_, "is-disabled");
#line 86 "../src/desktop_item.vala"
		gtk_widget_set_tooltip_text ((GtkWidget*) self, "");
#line 1135 "desktop_item.c"
	}
#line 89 "../src/desktop_item.vala"
	gtk_widget_queue_draw ((GtkWidget*) self);
#line 76 "../src/desktop_item.vala"
	g_object_notify_by_pspec ((GObject *) self, desktop_item_properties[DESKTOP_ITEM_IS_COPYING_PROPERTY]);
#line 1141 "desktop_item.c"
}

gboolean
desktop_item_get_is_mount (DesktopItem* self)
{
	gboolean result;
#line 94 "../src/desktop_item.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 95 "../src/desktop_item.vala"
	result = self->_mount;
#line 95 "../src/desktop_item.vala"
	return result;
#line 1154 "desktop_item.c"
}

void
desktop_item_set_is_mount (DesktopItem* self,
                           gboolean value)
{
#line 98 "../src/desktop_item.vala"
	g_return_if_fail (self != NULL);
#line 99 "../src/desktop_item.vala"
	self->_mount = value;
#line 98 "../src/desktop_item.vala"
	g_object_notify_by_pspec ((GObject *) self, desktop_item_properties[DESKTOP_ITEM_IS_MOUNT_PROPERTY]);
#line 1167 "desktop_item.c"
}

gboolean
desktop_item_get_is_special (DesktopItem* self)
{
	gboolean result;
#line 104 "../src/desktop_item.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 105 "../src/desktop_item.vala"
	result = self->_special_dir;
#line 105 "../src/desktop_item.vala"
	return result;
#line 1180 "desktop_item.c"
}

void
desktop_item_set_is_special (DesktopItem* self,
                             gboolean value)
{
#line 108 "../src/desktop_item.vala"
	g_return_if_fail (self != NULL);
#line 109 "../src/desktop_item.vala"
	self->_special_dir = value;
#line 108 "../src/desktop_item.vala"
	g_object_notify_by_pspec ((GObject *) self, desktop_item_properties[DESKTOP_ITEM_IS_SPECIAL_PROPERTY]);
#line 1193 "desktop_item.c"
}

const gchar*
desktop_item_get_item_type (DesktopItem* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 114 "../src/desktop_item.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 115 "../src/desktop_item.vala"
	_tmp0_ = self->_type;
#line 115 "../src/desktop_item.vala"
	result = _tmp0_;
#line 115 "../src/desktop_item.vala"
	return result;
#line 1209 "desktop_item.c"
}

const gchar*
desktop_item_get_label_name (DesktopItem* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 120 "../src/desktop_item.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 121 "../src/desktop_item.vala"
	_tmp0_ = self->_name;
#line 121 "../src/desktop_item.vala"
	result = _tmp0_;
#line 121 "../src/desktop_item.vala"
	return result;
#line 1225 "desktop_item.c"
}

void
desktop_item_set_label_name (DesktopItem* self,
                             const gchar* value)
{
	gchar* _tmp0_;
	GtkLabel* _tmp1_;
#line 124 "../src/desktop_item.vala"
	g_return_if_fail (self != NULL);
#line 125 "../src/desktop_item.vala"
	_tmp0_ = g_strdup (value);
#line 125 "../src/desktop_item.vala"
	_g_free0 (self->_name);
#line 125 "../src/desktop_item.vala"
	self->_name = _tmp0_;
#line 126 "../src/desktop_item.vala"
	_tmp1_ = self->label;
#line 126 "../src/desktop_item.vala"
	gtk_label_set_text (_tmp1_, value);
#line 124 "../src/desktop_item.vala"
	g_object_notify_by_pspec ((GObject *) self, desktop_item_properties[DESKTOP_ITEM_LABEL_NAME_PROPERTY]);
#line 1248 "desktop_item.c"
}

static void
desktop_item_class_init (DesktopItemClass * klass,
                         gpointer klass_data)
{
#line 21 "../src/desktop_item.vala"
	desktop_item_parent_class = g_type_class_peek_parent (klass);
#line 21 "../src/desktop_item.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_desktop_item_get_property;
#line 21 "../src/desktop_item.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_desktop_item_set_property;
#line 21 "../src/desktop_item.vala"
	G_OBJECT_CLASS (klass)->finalize = desktop_item_finalize;
#line 21 "../src/desktop_item.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DESKTOP_ITEM_IS_COPYING_PROPERTY, desktop_item_properties[DESKTOP_ITEM_IS_COPYING_PROPERTY] = g_param_spec_boolean ("is-copying", "is-copying", "is-copying", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 21 "../src/desktop_item.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DESKTOP_ITEM_IS_MOUNT_PROPERTY, desktop_item_properties[DESKTOP_ITEM_IS_MOUNT_PROPERTY] = g_param_spec_boolean ("is-mount", "is-mount", "is-mount", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 21 "../src/desktop_item.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DESKTOP_ITEM_IS_SPECIAL_PROPERTY, desktop_item_properties[DESKTOP_ITEM_IS_SPECIAL_PROPERTY] = g_param_spec_boolean ("is-special", "is-special", "is-special", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 21 "../src/desktop_item.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DESKTOP_ITEM_ITEM_TYPE_PROPERTY, desktop_item_properties[DESKTOP_ITEM_ITEM_TYPE_PROPERTY] = g_param_spec_string ("item-type", "item-type", "item-type", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 21 "../src/desktop_item.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DESKTOP_ITEM_LABEL_NAME_PROPERTY, desktop_item_properties[DESKTOP_ITEM_LABEL_NAME_PROPERTY] = g_param_spec_string ("label-name", "label-name", "label-name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 1273 "desktop_item.c"
}

static void
desktop_item_instance_init (DesktopItem * self,
                            gpointer klass)
{
}

static void
desktop_item_finalize (GObject * obj)
{
	DesktopItem * self;
#line 21 "../src/desktop_item.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_DESKTOP_ITEM, DesktopItem);
#line 26 "../src/desktop_item.vala"
	_g_free0 (self->_name);
#line 27 "../src/desktop_item.vala"
	_g_free0 (self->_type);
#line 30 "../src/desktop_item.vala"
	_g_object_unref0 (self->image);
#line 31 "../src/desktop_item.vala"
	_g_object_unref0 (self->label);
#line 32 "../src/desktop_item.vala"
	_g_object_unref0 (self->event_box);
#line 33 "../src/desktop_item.vala"
	_g_object_unref0 (self->main_layout);
#line 35 "../src/desktop_item.vala"
	_g_object_unref0 (self->original_image_pixbuf);
#line 37 "../src/desktop_item.vala"
	_g_object_unref0 (self->icon);
#line 21 "../src/desktop_item.vala"
	G_OBJECT_CLASS (desktop_item_parent_class)->finalize (obj);
#line 1306 "desktop_item.c"
}

 G_GNUC_NO_INLINE static GType
desktop_item_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (DesktopItemClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) desktop_item_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DesktopItem), 0, (GInstanceInitFunc) desktop_item_instance_init, NULL };
	GType desktop_item_type_id;
	desktop_item_type_id = g_type_register_static (gtk_flow_box_child_get_type (), "DesktopItem", &g_define_type_info, 0);
	return desktop_item_type_id;
}

GType
desktop_item_get_type (void)
{
	static volatile gsize desktop_item_type_id__once = 0;
	if (g_once_init_enter (&desktop_item_type_id__once)) {
		GType desktop_item_type_id;
		desktop_item_type_id = desktop_item_get_type_once ();
		g_once_init_leave (&desktop_item_type_id__once, desktop_item_type_id);
	}
	return desktop_item_type_id__once;
}

static void
_vala_desktop_item_get_property (GObject * object,
                                 guint property_id,
                                 GValue * value,
                                 GParamSpec * pspec)
{
	DesktopItem * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_DESKTOP_ITEM, DesktopItem);
#line 21 "../src/desktop_item.vala"
	switch (property_id) {
#line 21 "../src/desktop_item.vala"
		case DESKTOP_ITEM_IS_COPYING_PROPERTY:
#line 21 "../src/desktop_item.vala"
		g_value_set_boolean (value, desktop_item_get_is_copying (self));
#line 21 "../src/desktop_item.vala"
		break;
#line 21 "../src/desktop_item.vala"
		case DESKTOP_ITEM_IS_MOUNT_PROPERTY:
#line 21 "../src/desktop_item.vala"
		g_value_set_boolean (value, desktop_item_get_is_mount (self));
#line 21 "../src/desktop_item.vala"
		break;
#line 21 "../src/desktop_item.vala"
		case DESKTOP_ITEM_IS_SPECIAL_PROPERTY:
#line 21 "../src/desktop_item.vala"
		g_value_set_boolean (value, desktop_item_get_is_special (self));
#line 21 "../src/desktop_item.vala"
		break;
#line 21 "../src/desktop_item.vala"
		case DESKTOP_ITEM_ITEM_TYPE_PROPERTY:
#line 21 "../src/desktop_item.vala"
		g_value_set_string (value, desktop_item_get_item_type (self));
#line 21 "../src/desktop_item.vala"
		break;
#line 21 "../src/desktop_item.vala"
		case DESKTOP_ITEM_LABEL_NAME_PROPERTY:
#line 21 "../src/desktop_item.vala"
		g_value_set_string (value, desktop_item_get_label_name (self));
#line 21 "../src/desktop_item.vala"
		break;
#line 1370 "desktop_item.c"
		default:
#line 21 "../src/desktop_item.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 21 "../src/desktop_item.vala"
		break;
#line 1376 "desktop_item.c"
	}
}

static void
_vala_desktop_item_set_property (GObject * object,
                                 guint property_id,
                                 const GValue * value,
                                 GParamSpec * pspec)
{
	DesktopItem * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_DESKTOP_ITEM, DesktopItem);
#line 21 "../src/desktop_item.vala"
	switch (property_id) {
#line 21 "../src/desktop_item.vala"
		case DESKTOP_ITEM_IS_COPYING_PROPERTY:
#line 21 "../src/desktop_item.vala"
		desktop_item_set_is_copying (self, g_value_get_boolean (value));
#line 21 "../src/desktop_item.vala"
		break;
#line 21 "../src/desktop_item.vala"
		case DESKTOP_ITEM_IS_MOUNT_PROPERTY:
#line 21 "../src/desktop_item.vala"
		desktop_item_set_is_mount (self, g_value_get_boolean (value));
#line 21 "../src/desktop_item.vala"
		break;
#line 21 "../src/desktop_item.vala"
		case DESKTOP_ITEM_IS_SPECIAL_PROPERTY:
#line 21 "../src/desktop_item.vala"
		desktop_item_set_is_special (self, g_value_get_boolean (value));
#line 21 "../src/desktop_item.vala"
		break;
#line 21 "../src/desktop_item.vala"
		case DESKTOP_ITEM_LABEL_NAME_PROPERTY:
#line 21 "../src/desktop_item.vala"
		desktop_item_set_label_name (self, g_value_get_string (value));
#line 21 "../src/desktop_item.vala"
		break;
#line 1414 "desktop_item.c"
		default:
#line 21 "../src/desktop_item.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 21 "../src/desktop_item.vala"
		break;
#line 1420 "desktop_item.c"
	}
}

