/* desktop_menu.c generated by valac 0.56.3, the Vala compiler
 * generated from desktop_menu.vala, do not modify */

/*
Copyright 2022 Buddies of Budgie
Copyright 2021 Solus Project

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

#include <gtk/gtk.h>
#include <glib-object.h>
#include <gio/gdesktopappinfo.h>
#include <glib.h>
#include <glib/gi18n-lib.h>
#include <gio/gio.h>
#include <gdk/gdk.h>
#include <stdlib.h>
#include <string.h>

#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_DESKTOP_MENU (desktop_menu_get_type ())
#define DESKTOP_MENU(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DESKTOP_MENU, DesktopMenu))
#define DESKTOP_MENU_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DESKTOP_MENU, DesktopMenuClass))
#define IS_DESKTOP_MENU(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DESKTOP_MENU))
#define IS_DESKTOP_MENU_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DESKTOP_MENU))
#define DESKTOP_MENU_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DESKTOP_MENU, DesktopMenuClass))

typedef struct _DesktopMenu DesktopMenu;
typedef struct _DesktopMenuClass DesktopMenuClass;
typedef struct _DesktopMenuPrivate DesktopMenuPrivate;
enum  {
	DESKTOP_MENU_0_PROPERTY,
	DESKTOP_MENU_NUM_PROPERTIES
};
static GParamSpec* desktop_menu_properties[DESKTOP_MENU_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

struct _DesktopMenu {
	GtkMenu parent_instance;
	DesktopMenuPrivate * priv;
};

struct _DesktopMenuClass {
	GtkMenuClass parent_class;
};

struct _DesktopMenuPrivate {
	GDesktopAppInfo* budgie_app;
	GDesktopAppInfo* bcc_app;
};

static gint DesktopMenu_private_offset;
static gpointer desktop_menu_parent_class = NULL;

VALA_EXTERN GType desktop_menu_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DesktopMenu, g_object_unref)
VALA_EXTERN DesktopMenu* desktop_menu_new (void);
VALA_EXTERN DesktopMenu* desktop_menu_construct (GType object_type);
static void desktop_menu_on_budgie_settings_activated (DesktopMenu* self);
static void _desktop_menu_on_budgie_settings_activated_gtk_menu_item_activate (GtkMenuItem* _sender,
                                                                        gpointer self);
static void desktop_menu_on_system_settings_activated (DesktopMenu* self);
static void _desktop_menu_on_system_settings_activated_gtk_menu_item_activate (GtkMenuItem* _sender,
                                                                        gpointer self);
static void desktop_menu_finalize (GObject * obj);
static GType desktop_menu_get_type_once (void);

static inline gpointer
desktop_menu_get_instance_private (DesktopMenu* self)
{
	return G_STRUCT_MEMBER_P (self, DesktopMenu_private_offset);
}

static void
_desktop_menu_on_budgie_settings_activated_gtk_menu_item_activate (GtkMenuItem* _sender,
                                                                   gpointer self)
{
#line 34 "../src/desktop_menu.vala"
	desktop_menu_on_budgie_settings_activated ((DesktopMenu*) self);
#line 102 "desktop_menu.c"
}

static void
_desktop_menu_on_system_settings_activated_gtk_menu_item_activate (GtkMenuItem* _sender,
                                                                   gpointer self)
{
#line 35 "../src/desktop_menu.vala"
	desktop_menu_on_system_settings_activated ((DesktopMenu*) self);
#line 111 "desktop_menu.c"
}

DesktopMenu*
desktop_menu_construct (GType object_type)
{
	DesktopMenu * self = NULL;
	GDesktopAppInfo* _tmp0_;
	GDesktopAppInfo* _tmp1_;
	GtkMenuItem* budgie_item = NULL;
	GtkMenuItem* _tmp2_;
	GtkMenuItem* system_item = NULL;
	GtkMenuItem* _tmp3_;
#line 26 "../src/desktop_menu.vala"
	self = (DesktopMenu*) g_object_new (object_type, NULL);
#line 28 "../src/desktop_menu.vala"
	_tmp0_ = g_desktop_app_info_new ("budgie-desktop-settings.desktop");
#line 28 "../src/desktop_menu.vala"
	_g_object_unref0 (self->priv->budgie_app);
#line 28 "../src/desktop_menu.vala"
	self->priv->budgie_app = _tmp0_;
#line 29 "../src/desktop_menu.vala"
	_tmp1_ = g_desktop_app_info_new ("budgie-control-center.desktop");
#line 29 "../src/desktop_menu.vala"
	_g_object_unref0 (self->priv->bcc_app);
#line 29 "../src/desktop_menu.vala"
	self->priv->bcc_app = _tmp1_;
#line 31 "../src/desktop_menu.vala"
	_tmp2_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("Budgie Desktop Settings"));
#line 31 "../src/desktop_menu.vala"
	g_object_ref_sink (_tmp2_);
#line 31 "../src/desktop_menu.vala"
	budgie_item = _tmp2_;
#line 32 "../src/desktop_menu.vala"
	_tmp3_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("System Settings"));
#line 32 "../src/desktop_menu.vala"
	g_object_ref_sink (_tmp3_);
#line 32 "../src/desktop_menu.vala"
	system_item = _tmp3_;
#line 34 "../src/desktop_menu.vala"
	g_signal_connect_object (budgie_item, "activate", (GCallback) _desktop_menu_on_budgie_settings_activated_gtk_menu_item_activate, self, 0);
#line 35 "../src/desktop_menu.vala"
	g_signal_connect_object (system_item, "activate", (GCallback) _desktop_menu_on_system_settings_activated_gtk_menu_item_activate, self, 0);
#line 37 "../src/desktop_menu.vala"
	gtk_widget_show_all ((GtkWidget*) budgie_item);
#line 38 "../src/desktop_menu.vala"
	gtk_widget_show_all ((GtkWidget*) system_item);
#line 40 "../src/desktop_menu.vala"
	gtk_menu_shell_insert ((GtkMenuShell*) self, (GtkWidget*) budgie_item, 0);
#line 41 "../src/desktop_menu.vala"
	gtk_menu_shell_insert ((GtkMenuShell*) self, (GtkWidget*) system_item, 1);
#line 25 "../src/desktop_menu.vala"
	_g_object_unref0 (system_item);
#line 25 "../src/desktop_menu.vala"
	_g_object_unref0 (budgie_item);
#line 25 "../src/desktop_menu.vala"
	return self;
#line 168 "desktop_menu.c"
}

DesktopMenu*
desktop_menu_new (void)
{
#line 25 "../src/desktop_menu.vala"
	return desktop_menu_construct (TYPE_DESKTOP_MENU);
#line 176 "desktop_menu.c"
}

static void
desktop_menu_on_budgie_settings_activated (DesktopMenu* self)
{
	GError* _inner_error0_ = NULL;
#line 45 "../src/desktop_menu.vala"
	g_return_if_fail (self != NULL);
#line 185 "desktop_menu.c"
	{
		GDesktopAppInfo* _tmp0_;
		GdkDisplay* _tmp1_;
		GdkAppLaunchContext* _tmp2_;
		GdkAppLaunchContext* _tmp3_;
#line 47 "../src/desktop_menu.vala"
		_tmp0_ = self->priv->budgie_app;
#line 47 "../src/desktop_menu.vala"
		_tmp1_ = gdk_display_get_default ();
#line 47 "../src/desktop_menu.vala"
		_tmp2_ = gdk_display_get_app_launch_context (_tmp1_);
#line 47 "../src/desktop_menu.vala"
		_tmp3_ = _tmp2_;
#line 47 "../src/desktop_menu.vala"
		g_app_info_launch ((GAppInfo*) _tmp0_, NULL, (GAppLaunchContext*) _tmp3_, &_inner_error0_);
#line 47 "../src/desktop_menu.vala"
		_g_object_unref0 (_tmp3_);
#line 47 "../src/desktop_menu.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 205 "desktop_menu.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp4_;
		const gchar* _tmp5_;
#line 46 "../src/desktop_menu.vala"
		e = _inner_error0_;
#line 46 "../src/desktop_menu.vala"
		_inner_error0_ = NULL;
#line 49 "../src/desktop_menu.vala"
		_tmp4_ = e;
#line 49 "../src/desktop_menu.vala"
		_tmp5_ = _tmp4_->message;
#line 49 "../src/desktop_menu.vala"
		g_warning ("desktop_menu.vala:49: Failed to launch Budgie Desktop settings: %s", _tmp5_);
#line 46 "../src/desktop_menu.vala"
		_g_error_free0 (e);
#line 227 "desktop_menu.c"
	}
	__finally0:
#line 46 "../src/desktop_menu.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 46 "../src/desktop_menu.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 46 "../src/desktop_menu.vala"
		g_clear_error (&_inner_error0_);
#line 46 "../src/desktop_menu.vala"
		return;
#line 238 "desktop_menu.c"
	}
#line 51 "../src/desktop_menu.vala"
	gtk_menu_popdown ((GtkMenu*) self);
#line 242 "desktop_menu.c"
}

static void
desktop_menu_on_system_settings_activated (DesktopMenu* self)
{
	GError* _inner_error0_ = NULL;
#line 55 "../src/desktop_menu.vala"
	g_return_if_fail (self != NULL);
#line 251 "desktop_menu.c"
	{
		GDesktopAppInfo* _tmp0_;
		GdkDisplay* _tmp1_;
		GdkAppLaunchContext* _tmp2_;
		GdkAppLaunchContext* _tmp3_;
#line 57 "../src/desktop_menu.vala"
		_tmp0_ = self->priv->bcc_app;
#line 57 "../src/desktop_menu.vala"
		_tmp1_ = gdk_display_get_default ();
#line 57 "../src/desktop_menu.vala"
		_tmp2_ = gdk_display_get_app_launch_context (_tmp1_);
#line 57 "../src/desktop_menu.vala"
		_tmp3_ = _tmp2_;
#line 57 "../src/desktop_menu.vala"
		g_app_info_launch ((GAppInfo*) _tmp0_, NULL, (GAppLaunchContext*) _tmp3_, &_inner_error0_);
#line 57 "../src/desktop_menu.vala"
		_g_object_unref0 (_tmp3_);
#line 57 "../src/desktop_menu.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 271 "desktop_menu.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp4_;
		const gchar* _tmp5_;
#line 56 "../src/desktop_menu.vala"
		e = _inner_error0_;
#line 56 "../src/desktop_menu.vala"
		_inner_error0_ = NULL;
#line 59 "../src/desktop_menu.vala"
		_tmp4_ = e;
#line 59 "../src/desktop_menu.vala"
		_tmp5_ = _tmp4_->message;
#line 59 "../src/desktop_menu.vala"
		g_warning ("desktop_menu.vala:59: Failed to launch Budgie Control Center: %s", _tmp5_);
#line 56 "../src/desktop_menu.vala"
		_g_error_free0 (e);
#line 293 "desktop_menu.c"
	}
	__finally0:
#line 56 "../src/desktop_menu.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 56 "../src/desktop_menu.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 56 "../src/desktop_menu.vala"
		g_clear_error (&_inner_error0_);
#line 56 "../src/desktop_menu.vala"
		return;
#line 304 "desktop_menu.c"
	}
#line 61 "../src/desktop_menu.vala"
	gtk_menu_popdown ((GtkMenu*) self);
#line 308 "desktop_menu.c"
}

static void
desktop_menu_class_init (DesktopMenuClass * klass,
                         gpointer klass_data)
{
#line 21 "../src/desktop_menu.vala"
	desktop_menu_parent_class = g_type_class_peek_parent (klass);
#line 21 "../src/desktop_menu.vala"
	g_type_class_adjust_private_offset (klass, &DesktopMenu_private_offset);
#line 21 "../src/desktop_menu.vala"
	G_OBJECT_CLASS (klass)->finalize = desktop_menu_finalize;
#line 321 "desktop_menu.c"
}

static void
desktop_menu_instance_init (DesktopMenu * self,
                            gpointer klass)
{
#line 21 "../src/desktop_menu.vala"
	self->priv = desktop_menu_get_instance_private (self);
#line 330 "desktop_menu.c"
}

static void
desktop_menu_finalize (GObject * obj)
{
	DesktopMenu * self;
#line 21 "../src/desktop_menu.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_DESKTOP_MENU, DesktopMenu);
#line 22 "../src/desktop_menu.vala"
	_g_object_unref0 (self->priv->budgie_app);
#line 23 "../src/desktop_menu.vala"
	_g_object_unref0 (self->priv->bcc_app);
#line 21 "../src/desktop_menu.vala"
	G_OBJECT_CLASS (desktop_menu_parent_class)->finalize (obj);
#line 345 "desktop_menu.c"
}

 G_GNUC_NO_INLINE static GType
desktop_menu_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (DesktopMenuClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) desktop_menu_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DesktopMenu), 0, (GInstanceInitFunc) desktop_menu_instance_init, NULL };
	GType desktop_menu_type_id;
	desktop_menu_type_id = g_type_register_static (gtk_menu_get_type (), "DesktopMenu", &g_define_type_info, 0);
	DesktopMenu_private_offset = g_type_add_instance_private (desktop_menu_type_id, sizeof (DesktopMenuPrivate));
	return desktop_menu_type_id;
}

GType
desktop_menu_get_type (void)
{
	static volatile gsize desktop_menu_type_id__once = 0;
	if (g_once_init_enter (&desktop_menu_type_id__once)) {
		GType desktop_menu_type_id;
		desktop_menu_type_id = desktop_menu_get_type_once ();
		g_once_init_leave (&desktop_menu_type_id__once, desktop_menu_type_id);
	}
	return desktop_menu_type_id__once;
}

